Index: trunk/src/world_entities/npcs/adm_turret.cc
===================================================================
--- trunk/src/world_entities/npcs/adm_turret.cc	(revision 10698)
+++ trunk/src/world_entities/npcs/adm_turret.cc	(revision 10698)
@@ -0,0 +1,352 @@
+/*
+* orxonox - the future of 3D-vertical-scrollers
+*
+* Copyright (C) 2004 orx
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2, or (at your option)
+* any later version.
+*
+*     ### File Specific:
+*     main-programmer: Reto Luechinger
+*/
+
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WORLD_ENTITY
+#include "adm_turret.h"
+#include "weapons/weapon_manager.h"
+#include "weapons/weapon.h"
+#include "lib/util/loading/factory.h"
+#include "world_entities/projectiles/projectile.h"
+#include "loading/load_param.h"
+#include "debug.h"
+#include "loading/load_param_xml.h"
+
+#include "environments/bsp_entity.h"
+
+ObjectListDefinition(AdmTurret);
+CREATE_FACTORY(AdmTurret);
+
+/**
+*  Standard constructor
+*/
+AdmTurret::AdmTurret ()
+{
+	this->init();
+}
+
+/**
+* destructs the turret, deletes allocated memory
+*/
+AdmTurret::~AdmTurret ()
+{
+          // will be deleted
+}
+
+/**
+* Constructor with XML Element
+*/
+AdmTurret::AdmTurret (const  TiXmlElement* root)
+{
+	this->init();
+	if (root != NULL)
+        {
+		this->loadParams(root);
+	}
+}
+/**
+* XML Loader
+*/
+void AdmTurret::loadParams(const TiXmlElement* root)
+{
+	if (root != NULL)
+	{
+		WorldEntity::loadParams(root);
+
+		LoadParam(root, "target", this, AdmTurret, setTarget)
+			.describe("The filename of the World Entity, that is to be shot at")
+			.defaultValues("");
+                
+                LoadParam(root, "type", this, AdmTurret, setType)
+                        .describe("floor|ceil"); 
+
+		LoadParamXML(root, "Cannons", this, AdmTurret, addCannons)
+  			.describe("add cannons to ADM");
+		LoadParamXML(root, "Sensor", this, AdmTurret, addSensor)
+  			.describe("add sensor to ADM");
+		LoadParamXML(root, "Weapon", this, AdmTurret, addWeapon)
+  			.describe("add weapon to ADM");
+
+	}
+//         this->removeNodeFlags( PNODE_ALL );
+        this->addNodeFlags( PNODE_ROTATE_AND_MOVE );
+        this->addNodeFlags( PNODE_REPARENT_KEEP_POSITION );
+        
+        //HACK this is needed to get the correct coordinates instead (0, 0, 0)
+        this->updateNode( 0 );
+        
+        if ( this->isCeil )
+        {
+          Vector a = this->sensor->getRelCoor();
+          this->sensor->setRelCoor( -a.x, -a.y, -a.z );
+          a = this->cannons->getRelCoor();
+          this->cannons->setRelCoor( -a.x, -a.y, -a.z );
+        }
+}
+
+/**
+* Sets Target onto the World Entity with filename "target", given as String
+*/
+void AdmTurret::setTarget(const std::string& target)
+{
+	WorldEntity* targetEntity = WorldEntity::objectList().getObject(target);
+	if (targetEntity != NULL) 
+	{
+		this->myTarget = targetEntity;
+	}
+	else
+	{
+		PRINTF(1)("ERROR ADMTURRET : Target %s does not exist\n", target.c_str());
+	}
+}
+
+void AdmTurret::setType( const std::string& type )
+{
+  if ( type == "floor" )
+  {
+    this->isCeil = false;
+    return;
+  }
+  
+  if ( type == "ceil" )
+  {
+    this->isCeil = true;
+    return;
+  }
+  
+  //invalid argument
+  PRINTF(1)("%s is not a valid type for AdmTurret\n", type.c_str());
+  assert("false");
+}
+
+void AdmTurret::init()
+{
+	this->registerObject(this, AdmTurret::_objectList);
+        
+        this->bodyAngle = this->cannonAngle = 0.0f;
+        this->isActive = true;
+        this->range = 400;
+        this->isCeil = false;
+        this->playerVisible = false;
+	this->weapon = NULL;
+
+	
+}
+
+void AdmTurret::tick(float dt)
+{
+  WorldEntity::tick(dt);
+  if (this->weapon) this->weapon->fire(false);
+  this->updatePlayerVisible();
+
+  //rotate sensor 2PI/sec
+  this->sensor->setAbsDir( this->sensor->getAbsDir() * Quaternion( PI*2*dt, Vector( 0, -1, 0 ) ) );
+
+
+  Vector playerPos = this->myTarget->getAbsCoor() + Vector(0, 12, 0);
+  Vector ds = playerPos - ( this->cannons->getAbsCoor() );
+  if ( isActive && ds.len() <= range && playerVisible )
+  {
+    this->moveTowards( ds,  dt);
+    
+    //if target within +/- 2.5 degrees of aim -> fire
+    Vector dv1 = ds;
+    dv1.normalize();
+    Vector dv2 = this->cannons->getAbsDir().apply( Vector(-1, 0, 0));
+    dv2.normalize();
+    float angle = dv1.dot(dv2);
+    if (angle > 0.999)
+    {
+     	if (this->weapon) this->weapon->fire(true);
+    }
+  }
+  else
+    this->moveTowards( Vector(0, -1, 0), dt );
+}
+
+void AdmTurret::draw() const
+{
+  WorldEntity::draw();
+
+#if 0
+  glMatrixMode(GL_MODELVIEW);
+  glPushMatrix();
+
+  glPushAttrib(GL_ENABLE_BIT);
+
+  glDisable(GL_LIGHTING);
+  glDisable(GL_TEXTURE_2D);
+  glDisable(GL_BLEND);
+  glLineWidth(2.0);
+
+
+  Vector mp = this->cannons->getAbsCoor();
+  Vector op = this->cannons->getAbsDir().apply( Vector(-1, 0, 0) );
+  op *= 100;
+  op += mp;
+
+  glColor3f(1.0, 0.0, 0.0 );
+  glBegin(GL_LINE_STRIP);
+    glVertex3f(mp.x, mp.y, mp.z);
+    glVertex3f(op.x, op.y, op.z);
+  glEnd();
+
+  op = this->myTarget->getAbsCoor() - ( this->cannons->getAbsCoor() );
+  op += mp;
+
+  glColor3f(0.0, 1.0, 0.0 );
+  glBegin(GL_LINE_STRIP);
+    glVertex3f(mp.x, mp.y, mp.z);
+    glVertex3f(op.x, op.y, op.z);
+  glEnd();
+  
+  glPopAttrib();
+  glPopMatrix();
+#endif
+}
+
+void AdmTurret::collidesWith(WorldEntity* entity, const Vector& location)
+{
+}
+
+void AdmTurret::activate()
+{
+}
+
+void AdmTurret::deactivate()
+{
+}
+
+void AdmTurret::addCannons( const TiXmlElement * root )
+{
+  this->cannons = new WorldEntity();
+	this->cannons->setParent(this);
+	this->cannons->loadParams( root );
+
+	//this->cannons->addNodeFlags(PNODE_PROHIBIT_DELETE_WITH_PARENT);
+	//this->cannons->addNodeFlags(PNODE_PROHIBIT_CHILD_DELETE);
+	
+	this->cannons->toList( getOMListNumber() );
+
+
+}
+
+void AdmTurret::addWeapon( const TiXmlElement * root )
+{
+	this->weapon = new BspWeapon();
+	this->weapon->setParent( this->cannons );
+	this->weapon->loadParams(root);
+	this->weapon->toList( getOMListNumber() );
+	//this->weapon->setAbsCoor( this->cannons->getAbsCoor() );
+	this->weapon->setAbsDir( this->weapon->getAbsDir() * Quaternion( PI, Vector(0, 1, 0) ) );
+}
+
+void AdmTurret::addSensor( const TiXmlElement * root )
+{
+  this->sensor = new WorldEntity();
+	this->sensor->setParent(this);
+	this->sensor->loadParams( root );
+
+	//this->sensor->addNodeFlags(PNODE_PROHIBIT_DELETE_WITH_PARENT);
+	//this->sensor->addNodeFlags(PNODE_PROHIBIT_CHILD_DELETE);
+	this->sensor->toList( getOMListNumber() );
+}
+
+void AdmTurret::moveTowards( Vector targetDir, float dt )
+{
+  if ( this->cannons->getParent() != NullParent::getNullParent() )
+  {
+    this->cannons->setParent( NullParent::getNullParent() );
+    this->cannons->shiftCoor( this->getAbsCoor() );
+    
+    this->sensor->setParent( NullParent::getNullParent() );
+    this->sensor->shiftCoor( this->getAbsCoor() );
+  }
+  
+  targetDir.normalize();
+  
+  float dAngle = dt;
+  
+  float bestResult = -1.0f;
+  Quaternion bestBodyRot;
+  Quaternion bestCannonRot;
+  float bestBodyAngle = 0.0f;
+  float bestCannonAngle = 0.0f;
+  
+   Quaternion baseRot(0, Vector(1, 0, 0));
+   if ( isCeil )
+   {
+     baseRot = Quaternion( PI, Vector( 1, 0, 0 ) );
+   }
+  
+  for ( int dBodyAngle = -1; dBodyAngle<2; dBodyAngle++ )
+  {
+    for ( int dCannonAngle = -1; dCannonAngle<2; dCannonAngle++ )
+    {
+      float bodyAngle = this->bodyAngle + dBodyAngle*dAngle;
+      float cannonAngle = this->cannonAngle + dCannonAngle*dAngle;
+      
+      while ( bodyAngle > 2*PI )
+        bodyAngle -= 2*PI;
+      while ( bodyAngle < 0 )
+        bodyAngle += 2*PI;
+      while ( cannonAngle > 2*PI )
+        cannonAngle -= 2*PI;
+      while ( cannonAngle < 0 )
+        cannonAngle += 2*PI;
+      
+      Quaternion bodyRot( bodyAngle, Vector( 0, 1, 0 ) );
+      Quaternion cannonRot( cannonAngle, Vector( 0, 0, 1) );
+      
+       bodyRot = baseRot * bodyRot;
+       cannonRot = baseRot * cannonRot;
+      
+      float result = (bodyRot * cannonRot).apply( Vector( -1, 0, 0 ) ).dot( targetDir );
+      
+      if ( result > bestResult )
+      {
+        bestResult = result;
+        bestBodyRot = bodyRot;
+        bestBodyAngle = bodyAngle;
+        bestCannonRot = cannonRot;
+        bestCannonAngle = cannonAngle;
+      }
+    }
+  }
+  
+  this->bodyAngle = bestBodyAngle;
+  this->cannonAngle = bestCannonAngle;
+  
+  this->setAbsDir( bestBodyRot );
+  this->cannons->setAbsDir( bestBodyRot * bestCannonRot );
+}
+
+void AdmTurret::updatePlayerVisible( )
+{
+  std::list<WorldEntity*>::iterator entityIterator;
+  // for all bsp managers check all entities
+  Vector pos = this->cannons->getAbsCoor();
+  Vector dir = this->myTarget->getAbsCoor() - pos;
+
+
+  this->playerVisible = true;
+  for( ObjectList<BspEntity>::const_iterator bspIterator = BspEntity::objectList().begin();
+       bspIterator != BspEntity::objectList().end();
+       bspIterator++) {
+      float res = (dynamic_cast<BspEntity*>(*bspIterator)->getBspManager())->checkCollisionRay( pos, dir, dir.len() + 1 );
+      
+      if ( res < dir.len() )
+        this->playerVisible = false;
+  }
+}
Index: trunk/src/world_entities/npcs/adm_turret.h
===================================================================
--- trunk/src/world_entities/npcs/adm_turret.h	(revision 10698)
+++ trunk/src/world_entities/npcs/adm_turret.h	(revision 10698)
@@ -0,0 +1,62 @@
+/*
+* file groundTurret.h
+* A weapon that is fix located, and automatically shooting at a target.
+*/
+
+#ifndef _ADM_TURRET_H
+#define _ADM_TURRET_H
+
+//#include "sound_buffer.h"
+//#include "sound_source.h"
+
+#include "world_entity.h"
+#include "weapons/bsp_weapon.h"
+
+class AdmTurret : public WorldEntity
+      {
+                   ObjectListDeclaration(AdmTurret);
+      public:
+                   AdmTurret ();
+                   AdmTurret (const  TiXmlElement* root);
+                   virtual ~AdmTurret();
+                   
+                   void init();
+                   void loadParams(const TiXmlElement* root);
+                   
+                   virtual void tick(float dt);
+                   virtual void draw() const;
+                   virtual void collidesWith(WorldEntity* entity, const Vector& location);
+                   
+                   virtual void activate();
+                   virtual void deactivate();
+                   
+                   virtual void setTarget(const std::string& target);
+                   
+      private:
+                   WorldEntity* cannons;
+                   WorldEntity* sensor;
+                   WorldEntity* myTarget;
+
+		   void addCannons(const TiXmlElement* root);
+		   void addSensor(const TiXmlElement* root);
+		   void addWeapon(const TiXmlElement* root);
+
+		   void moveTowards( Vector targetDir, float dt );
+                   
+                   float bodyAngle;
+                   float cannonAngle;
+                   
+                   bool isActive;
+                   float range;
+                   
+                   bool isCeil;
+                   void setType( const std::string& type );
+                   
+                   bool playerVisible;
+                   void updatePlayerVisible();
+
+		BspWeapon* weapon;
+      };
+
+#endif
+
Index: trunk/src/world_entities/npcs/npc.cc
===================================================================
--- trunk/src/world_entities/npcs/npc.cc	(revision 10697)
+++ trunk/src/world_entities/npcs/npc.cc	(revision 10698)
@@ -407,5 +407,5 @@
       {
         int slot = ws->getWeaponSlot();
-        int side = ws->getWeaponSide();
+//         int side = ws->getWeaponSide(); //FIXME / REMOVE: is not used
         this->getWeaponManager().setSlotPosition(slot, (*it).second->getCenter());
         this->getWeaponManager().setSlotDirection(slot, ws->getRelDir());
Index: trunk/src/world_entities/playable.h
===================================================================
--- trunk/src/world_entities/playable.h	(revision 10697)
+++ trunk/src/world_entities/playable.h	(revision 10698)
@@ -32,5 +32,5 @@
   typedef enum {
     Vertical         =  1,       //!< Vertical (seen from left or right/move in x-z)
-    Horizontal       =  2,       //!< Horizontal (seet from the top/move in x-y)
+    Horizontal       =  2,       //!< Horizontal (seen from the top/move in x-y)
     FromBehind       =  4,       //!< Seen from behind (move in z-y)
     Full3D           =  8,       //!< Full featured 3D-mode. (move in all directions x-y-z)
Index: trunk/src/world_entities/player.cc
===================================================================
--- trunk/src/world_entities/player.cc	(revision 10697)
+++ trunk/src/world_entities/player.cc	(revision 10698)
@@ -19,4 +19,5 @@
 
 #include "event_handler.h"
+#include "creatures/fps_player.h"
 
 #include "state.h"
@@ -74,9 +75,19 @@
     PRINTF(4)("Enter new Playable\n");
     this->playable = playable;
-    this->_hud.setArmorWidget(this->playable->getHealthWidget());
-    if (dynamic_cast<SpaceShip*>(this->playable) != 0)
+    
+    if( playable->isA(FPSPlayer::staticClassID()) )
+    {
+    	this->_hud.setMode(Hud::FirstPerson);
+    	this->_hud.setHealthWidget(this->playable->getHealthWidget());
+    }
+    else
+    {
+    	this->_hud.setMode(Hud::Full3D);
+    	this->_hud.setHealthWidget(this->playable->getHealthWidget());
+    }
+    /*if (dynamic_cast<SpaceShip*>(this->playable) != 0)
       this->_hud.setWeaponManager(&this->playable->getWeaponManager(), &dynamic_cast<SpaceShip*>(this->playable)->getWeaponManagerSecondary());
     else
-      this->_hud.setWeaponManager(&this->playable->getWeaponManager());
+      this->_hud.setWeaponManager(&this->playable->getWeaponManager());*/
 
     this->playable->setPlayer(this);
Index: trunk/src/world_entities/projectiles/acid_splash.cc
===================================================================
--- trunk/src/world_entities/projectiles/acid_splash.cc	(revision 10697)
+++ trunk/src/world_entities/projectiles/acid_splash.cc	(revision 10698)
@@ -116,6 +116,6 @@
   this->toList(OM_NULL);
   //this->toList(OM_DEAD);
-  this->removeNode();
-  
+//   this->removeNode();
+
   AcidSplash::fastFactory->kill(this);
 }
Index: trunk/src/world_entities/projectiles/hbolt.cc
===================================================================
--- trunk/src/world_entities/projectiles/hbolt.cc	(revision 10697)
+++ trunk/src/world_entities/projectiles/hbolt.cc	(revision 10698)
@@ -46,5 +46,5 @@
   this->setMinEnergy(10);
   this->setHealthMax(0);
-  this->lifeSpan = 2.0;
+  this->lifeSpan = 3.0;
 
   this->angle = 0;
@@ -116,5 +116,5 @@
 
   this->toList(OM_DEAD);
-  this->removeNode();
+//   this->removeNode();
   HBolt::fastFactory->kill(this);
 
@@ -177,5 +177,5 @@
   glPushAttrib(GL_ENABLE_BIT);
   glDisable(GL_LIGHTING);
-//   glDisable(GL_FOG);
+  glDisable(GL_FOG);
 
   glMatrixMode(GL_MODELVIEW);
@@ -184,4 +184,6 @@
 //     float matrix[4][4];
     glTranslatef (this->getAbsCoor ().x, this->getAbsCoor ().y, this->getAbsCoor ().z);
+    this->halo->draw();
+
     Vector tmpRot = this->getAbsDir().getSpacialAxis();
     glRotatef (this->getAbsDir().getSpacialAxisAngle(), tmpRot.x, tmpRot.y, tmpRot.z );
@@ -189,5 +191,4 @@
 //     glMultMatrixf((float*)matrix);
     this->getModel()->draw();
-    this->halo->draw();
 
   glPopMatrix();
Index: trunk/src/world_entities/projectiles/laser.cc
===================================================================
--- trunk/src/world_entities/projectiles/laser.cc	(revision 10697)
+++ trunk/src/world_entities/projectiles/laser.cc	(revision 10698)
@@ -100,5 +100,5 @@
 
   this->toList(OM_NULL);
-  this->removeNode();
+//   this->removeNode();
   Laser::fastFactory->kill(this);
 }
Index: trunk/src/world_entities/projectiles/lbolt.cc
===================================================================
--- trunk/src/world_entities/projectiles/lbolt.cc	(revision 10697)
+++ trunk/src/world_entities/projectiles/lbolt.cc	(revision 10698)
@@ -62,7 +62,8 @@
   this->halo = new Billboard();
   this->halo->setSize(.35, .35);
-  this->halo->setTexture("hbolt_halo.png");
+  this->halo->setTexture("hbolt_halo.jpg");
   this->halo->setVisibility(false);
 
+  this->halo->setPulse();
 
 }
@@ -120,5 +121,5 @@
 
   this->toList(OM_DEAD);
-  this->removeNode();
+//   this->removeNode();
   LBolt::fastFactory->kill(this);
 }
@@ -148,4 +149,6 @@
 
   angle += LBolt::rotationSpeed * dt;
+  if(angle > 360)
+    angle -= 360;
 
   for( ObjectList<NPC>::const_iterator eIterator = NPC::objectList().begin(); eIterator !=NPC::objectList().end(); eIterator++)
@@ -183,13 +186,16 @@
     float matrix[4][4];
     glTranslatef (this->getAbsCoor ().x, this->getAbsCoor ().y, this->getAbsCoor ().z);
-    Vector tmpRot = this->getAbsDir().getSpacialAxis();
+    this->halo->draw();
+
+    Vector tmpRot;
+    tmpRot = this->flightDirection.getNormalized();
+    glRotatef(this->angle, tmpRot.x, tmpRot.y, tmpRot.z);
+    tmpRot = this->getAbsDir().getSpacialAxis();
     glRotatef (this->getAbsDir().getSpacialAxisAngle(), tmpRot.x, tmpRot.y, tmpRot.z );
-    glRotatef(this->angle, 1.0, 0.0, 0.0);
+
     this->getAbsDir().matrix (matrix);
     glMultMatrixf((float*)matrix);
     this->getModel()->draw();
 
-    this->halo->draw();
-
   glPopMatrix();
   glPopAttrib();
Index: trunk/src/world_entities/projectiles/mbolt.cc
===================================================================
--- trunk/src/world_entities/projectiles/mbolt.cc	(revision 10697)
+++ trunk/src/world_entities/projectiles/mbolt.cc	(revision 10698)
@@ -145,5 +145,5 @@
   this->toList(OM_NULL);
   //this->toList(OM_DEAD);
-  this->removeNode();
+//   this->removeNode();
   MBolt::fastFactory->kill(this);
 }
@@ -212,5 +212,6 @@
   float matrix[4][4];
   glTranslatef (this->getAbsCoor ().x, this->getAbsCoor ().y, this->getAbsCoor ().z);
-  glRotatef(this->angle, 1.0f, 0.0f, 0.0f); //spinning missile
+//   glRotatef(this->angle, 1.0f, 0.0f, 0.0f); //spinning missile
+  glRotatef(this->angle, this->flightDirection.x, this->flightDirection.y, this->flightDirection.z);
   this->getAbsDir().matrix (matrix);
   glMultMatrixf((float*)matrix);
Index: trunk/src/world_entities/projectiles/nadion_blast.cc
===================================================================
--- trunk/src/world_entities/projectiles/nadion_blast.cc	(revision 10698)
+++ trunk/src/world_entities/projectiles/nadion_blast.cc	(revision 10698)
@@ -0,0 +1,231 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004-2006 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific
+   main-programmer: Marc Schaerrer
+   co-programmer: Benjamin Grauer
+
+*/
+
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WEAPON
+
+#include "nadion_blast.h"
+
+#include "state.h"
+#include "model.h"
+
+#include "world_entities/npcs/npc.h"
+
+#include "particles/dot_emitter.h"
+#include "particles/sprite_particles.h"
+
+#include "space_ships/space_ship.h"
+
+#include <cassert>
+#include "debug.h"
+
+#include "static_model.h"
+
+#include "effects/trail.h"
+
+
+
+ObjectListDefinition(NadionBlast);
+CREATE_FAST_FACTORY_STATIC(NadionBlast);
+
+/**
+ *  standard constructor
+*/
+NadionBlast::NadionBlast () : Projectile()
+{
+  this->registerObject(this, NadionBlast::_objectList);
+  this->loadModel("models/projectiles/mbolt.obj",4);
+
+
+  //this->loadModel("models/projectiles/laser.obj");
+
+  this->setMinEnergy(4);
+  this->setHealthMax(0);
+  this->lifeSpan = 2.5;
+  this->angle     = 0;
+
+  //this->emitter = new DotEmitter(1000, 0, 0);
+  this->emitter = new DotEmitter(50, 0, 0);
+  this->emitter->setParent(this);
+  this->emitter->setSpread(M_PI,M_PI);
+  this->emitter->setInheritSpeed(this->velocity.len());
+  this->emitter->setEmissionRate(500.0);
+  this->emitter->setEmissionVelocity(this->velocity.len());
+
+  this->mat = new Material("NadionBlast");
+  //this->mat->setBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
+  this->mat->setBlendFunc(GL_SRC_ALPHA,GL_ONE);
+  this->mat->setDiffuse(1,1,1);
+  this->mat->setDiffuseMap("laser_add.png");
+  this->mat->setDiffuseMap("laser2.png",1);
+
+  dynamic_cast<StaticModel*>(this->getModel())->addMaterial(*this->mat);
+  dynamic_cast<StaticModel*>(this->getModel())->finalize();
+
+  dynamic_cast<StaticModel*>(this->getModel())->rebuild();
+  //this->buildObbTree(4);
+
+//   this->trail = new Trail(6, 4, .1, this);
+  //this->trail->setParent( this);
+//   this->trail->setTexture( "textures/laser.png");
+//   this->trail->setAbsCoor(this->getAbsCoor() - Vector(.7,0,0));
+//   this->trail->setAbsCoor(this->getAbsCoor() - this->getVelocity().getNormalized() * .7);
+
+}
+
+
+/**
+ *  standard deconstructor
+ *
+ */
+NadionBlast::~NadionBlast ()
+{
+
+  if (NadionBlast::explosionParticles != NULL && NadionBlast::objectList().size() <= 1)
+  {
+    if (ParticleSystem::objectList().exists(NadionBlast::explosionParticles))
+      delete NadionBlast::explosionParticles;
+    NadionBlast::explosionParticles = NULL;
+    PRINTF(1)("Deleting NadionBlast Explosion Particles\n");
+  }
+
+  delete this->emitter;
+//   delete this->trail;
+}
+
+SpriteParticles* NadionBlast::explosionParticles = NULL;
+
+void NadionBlast::activate()
+{
+  this->origList = this->getOMListNumber();
+  this->toList(OM_ENVIRON);
+  if (unlikely(NadionBlast::explosionParticles == NULL))
+  {
+    NadionBlast::explosionParticles = new SpriteParticles(1000);
+    NadionBlast::explosionParticles->setName("NadionBlastExplosionParticles");
+    NadionBlast::explosionParticles->setLifeSpan(.2, .1);
+    NadionBlast::explosionParticles->setRadius(0.0, 10.0);
+    NadionBlast::explosionParticles->setRadius(.5, 6.0);
+    NadionBlast::explosionParticles->setRadius(1.0, 3.0);
+    NadionBlast::explosionParticles->setColor(0.0, 1,1,0,.9);
+    NadionBlast::explosionParticles->setColor(0.5, .8,.8,0,.5);
+    NadionBlast::explosionParticles->setColor(1.0, .8,.8,.7,.0);
+  }
+
+  this->setPhysDamage(10);
+  this->setElecDamage(0);
+  this->setHealth(0);
+
+  this->emitter->setSpread(0);
+  this->emitter->setEmissionRate(10.0);
+  this->emitter->setEmissionVelocity(50);
+}
+
+
+void NadionBlast::deactivate()
+{
+  assert (NadionBlast::explosionParticles != NULL);
+  NadionBlast::explosionParticles->removeEmitter(this->emitter);
+  this->lifeCycle = 0.0;
+
+  this->lifeCycle = 0.0;
+  this->toList(OM_NULL);
+  //this->toList(OM_DEAD);
+//   this->removeNode();
+  NadionBlast::fastFactory->kill(this);
+}
+
+/*
+void NadionBlast::hit (float damage, WorldEntity* entity )
+{
+
+  if (this->hitEntity != entity)
+    this->destroy( entity );
+  this->hitEntity = entity;
+ // dynamic_cast<SpaceShip*>(entity)->damage(this->getPhysDamage(),this->getElecDamage());
+  //this->destroy(this);
+  this->deactivate();
+
+  return;
+
+}*/
+
+/**
+ *  signal tick, time dependent things will be handled here
+ * @param dt time since last tick
+*/
+void NadionBlast::tick (float dt)
+{
+  //Vector v = *this->flightDirection * ( this->speed * time * 1000 + 0.1);
+  Vector v = this->velocity * dt;
+  this->shiftCoor(v);
+
+  if (this->tickLifeCycle(dt))
+    this->deactivate();
+
+  this->angle += NadionBlast::rotationSpeed * dt;
+//   this->trail->tick(dt);
+
+  for( ObjectList<NPC>::const_iterator eIterator = NPC::objectList().begin(); eIterator !=NPC::objectList().end(); eIterator++)
+  {
+    if( ((*eIterator)->getOMListNumber() != (this->origList -1))  && ((*eIterator)->getAbsCoor() - this->getAbsCoor()).len() <= 8)
+    {
+      (*eIterator)->destroy(this); //hit (this->getDamage(),this);
+      this->deactivate();
+      PRINTF(0)("NadionBlast destroyed\n");
+    }
+  }
+}
+
+/**
+ *  the function gets called, when the projectile is destroyed
+*/
+void NadionBlast::destroy (WorldEntity* killer)
+{
+  //this->deactivate();
+  Projectile::destroy( killer );
+  PRINTF(5)("DESTROY NadionBlast\n");
+  this->lifeCycle = .95; //!< @todo calculate this usefully.
+
+  this->emitter->setSystem(NadionBlast::explosionParticles);
+}
+
+
+void NadionBlast::draw () const
+{
+  glPushAttrib(GL_ENABLE_BIT);
+  glDisable(GL_LIGHTING);
+
+  glPushMatrix();
+  float matrix[4][4];
+  glTranslatef (this->getAbsCoor ().x, this->getAbsCoor ().y, this->getAbsCoor ().z);
+//   glRotatef(this->angle, 1.0f, 0.0f, 0.0f); //spinning missile
+  glRotatef(this->angle, this->flightDirection.x, this->flightDirection.y, this->flightDirection.z);
+  this->getAbsDir().matrix (matrix);
+  glMultMatrixf((float*)matrix);
+
+  glScalef(0.75/6, 0.7/16, 0.7/16);  // no double rescale
+
+  this->mat->select();
+  dynamic_cast<StaticModel*>(this->getModel())->draw();
+  this->mat->unselect();
+//   glScalef(4/.75,16/.7,16/.7);
+//   glTranslatef(-3,0,0);
+//   this->trail->draw();
+  glPopMatrix();
+  glPopAttrib();
+
+}
Index: trunk/src/world_entities/projectiles/nadion_blast.h
===================================================================
--- trunk/src/world_entities/projectiles/nadion_blast.h	(revision 10698)
+++ trunk/src/world_entities/projectiles/nadion_blast.h	(revision 10698)
@@ -0,0 +1,54 @@
+/*!
+ * @file nadion_blast.h
+ * @brief nadion blast
+*/
+
+#ifndef _NADION_BLAST_H
+#define _NADION_BLAST_H
+
+#include "projectile.h"
+#include "material.h"
+
+class Vector;
+class Weapon;
+class SpriteParticles;
+class ParticleEmitter;
+class FastFactory;
+class Trail;
+
+class NadionBlast : public Projectile
+{
+  ObjectListDeclaration(NadionBlast);
+  public:
+    NadionBlast ();
+    virtual ~NadionBlast ();
+
+
+    virtual void activate();
+    virtual void deactivate();
+
+//     virtual void hit (float damage, WorldEntity* entity);
+
+    virtual void destroy (WorldEntity* killer);
+
+    virtual void tick (float dt);
+    virtual void draw () const;
+
+  private:
+    static FastFactory*               fastFactory;
+    static SpriteParticles*           explosionParticles;
+
+//     Trail*                            trail;
+
+    float                             angle;
+    static const float                rotationSpeed = 1080;
+
+    ParticleEmitter*                  emitter;
+
+    Material*                         mat;
+
+
+//     WorldEntity* hitEntity; // FIXME TEMPORARY
+};
+
+#endif /* _NADION_BLAST_H */
Index: trunk/src/world_entities/projectiles/plasma_pulse.cc
===================================================================
--- trunk/src/world_entities/projectiles/plasma_pulse.cc	(revision 10698)
+++ trunk/src/world_entities/projectiles/plasma_pulse.cc	(revision 10698)
@@ -0,0 +1,146 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004-2006 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific
+   main-programmer: Marc Schaerrer
+   co-programmer: Benjamin Grauer, Nicolas Schlumberger
+
+*/
+
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WEAPON
+
+#include "plasma_pulse.h"
+
+#include "state.h"
+
+#include <cassert>
+#include "debug.h"
+
+
+ObjectListDefinition(PlasmaPulse);
+CREATE_FAST_FACTORY_STATIC(PlasmaPulse);
+
+/**
+ *  standard constructor
+*/
+PlasmaPulse::PlasmaPulse () : Projectile()
+{
+  this->registerObject(this, PlasmaPulse::_objectList);
+
+
+  this->setMinEnergy(1);
+  this->setHealthMax(0);
+  this->lifeSpan = 2.0;
+
+  this->grid = new Billboard();
+  this->grid->setSize(.2, .2);
+  this->grid->setPulseMagnitude(.8);
+  this->grid->setParent(this);
+  this->grid->setVisibility(false);
+  this->grid->setPulse();
+  this->grid->setTexture( "textures/plasma.png");
+  this->grid->toList(OM_ENVIRON);
+/*
+  this->blink = new Blink();
+  this->grid->setParent(this);
+  this->grid->setVisibility(false);
+  this->blink->setSize(1.0 );
+  this->blink->setPeriod(.4);
+  this->blink->setColor(10, 250, 150);
+  this->blink->loadBlinkSequence( "66678998766" );
+  this->blink->toList(OM_ENVIRON);*/
+}
+
+
+/**
+ *  standard deconstructor
+ *
+ */
+PlasmaPulse::~PlasmaPulse ()
+{
+  this->grid->toList(OM_DEAD);
+//   this->blink->toList(OM_DEAD);
+}
+
+
+void PlasmaPulse::activate()
+{
+  this->origList = this->getOMListNumber();
+  this->toList(OM_ENVIRON);
+  this->grid->setVisibility(true);
+//   this->blink->setVisibility(true);
+
+  this->setPhysDamage(10);
+  this->setElecDamage(0);
+  this->setHealth(0);
+}
+
+
+void PlasmaPulse::deactivate()
+{
+  this->lifeCycle = 0.0;
+
+  this->grid->setVisibility(false);
+//   this->blink->setVisibility(false);
+  this->lifeCycle = 0.0;
+  this->toList(OM_NULL);
+//   this->removeNode();
+
+  PlasmaPulse::fastFactory->kill(this);
+}
+
+/**
+ *  signal tick, time dependent things will be handled here
+ * @param dt time since last tick
+*/
+void PlasmaPulse::tick (float dt)
+{
+  Vector v = this->velocity * dt;
+  this->shiftCoor(v);
+
+  if (this->tickLifeCycle(dt))
+    this->deactivate();
+
+  this->grid->tick(dt);
+
+  for( ObjectList<Playable>::const_iterator eIterator = Playable::objectList().begin(); eIterator !=Playable::objectList().end(); eIterator++)
+  {
+    if( ((*eIterator)->getOMListNumber() != (this->origList -1))  && ((*eIterator)->getAbsCoor() - this->getAbsCoor()).len() <= 3)
+    {
+      (*eIterator)->hit (this->getDamage(),this);
+      this->deactivate();
+    }
+  }
+
+}
+
+/**
+ *  the function gets called, when the projectile is destroyed
+*/
+void PlasmaPulse::destroy (WorldEntity* killer)
+{
+  this->deactivate();
+  Projectile::destroy( killer );
+  PRINTF(5)("DESTROY PlasmaPulse\n");
+  this->lifeCycle = .95; //!< @todo calculate this usefully.
+}
+
+
+void PlasmaPulse::draw () const
+{
+  glPushMatrix();
+    glEnable( GL_ALPHA_TEST);
+    glAlphaFunc( GL_GEQUAL, .5);
+    this->grid->draw();
+//     this->blink->draw();
+  glPopMatrix();
+
+}
Index: trunk/src/world_entities/projectiles/plasma_pulse.h
===================================================================
--- trunk/src/world_entities/projectiles/plasma_pulse.h	(revision 10698)
+++ trunk/src/world_entities/projectiles/plasma_pulse.h	(revision 10698)
@@ -0,0 +1,39 @@
+/*!
+ * @file plasma_pulse.h
+ * @brief Pulsing Plasma projectile
+*/
+
+#ifndef _PLASMAPULSE_H
+#define _PLASMAPULSE_H
+
+#include "projectile.h"
+#include "effects/billboard.h"
+#include "effects/blink.h"
+
+class Vector;
+class Weapon;
+class FastFactory;
+class Wobblegrid;
+
+class PlasmaPulse : public Projectile
+{
+  ObjectListDeclaration(PlasmaPulse);
+  public:
+    PlasmaPulse ();
+    virtual ~PlasmaPulse ();
+
+    virtual void activate();
+    virtual void deactivate();
+
+    virtual void destroy (WorldEntity* killer);
+
+    virtual void tick (float dt);
+    virtual void draw () const;
+
+  private:
+    static FastFactory*               fastFactory;
+    Billboard*                        grid;
+//     Blink*                            blink;
+};
+
+#endif /* _PLASMAPULSE_H */
Index: trunk/src/world_entities/projectiles/rail_projectile.cc
===================================================================
--- trunk/src/world_entities/projectiles/rail_projectile.cc	(revision 10697)
+++ trunk/src/world_entities/projectiles/rail_projectile.cc	(revision 10698)
@@ -99,5 +99,5 @@
 
   this->toList(OM_NULL);
-  this->removeNode();
+//   this->removeNode();
   RailProjectile::fastFactory->kill(this);
 }
